# Beispiel fr Ansteuerung USB 31128
# Bentigt min. Python 2.5 fr ctypes Modul (http://python.net/crew/theller/ctypes/tutorial.html)

from ctypes import *
DLL = cdll.GUSB_Platform

# Typedefs / Parameter / Variable

class GUSB_Platform_Card_Info(Structure):
  _fields_ = [("PID", c_ulong),("Serial", c_ulong),("Highspeed", c_ulong),("TypeIndex", c_ulong)]

class GUSB_Platform_DriverInfo(Structure):
  _fields_ = [("DllVersion", c_ulong),("DriverVersion", c_ulong),("CardCount", c_ulong),("CardInfo", GUSB_Platform_Card_Info * 128)]
  
LengthInByte = 5000
pDriverInfo = pointer(GUSB_Platform_DriverInfo())

DeviceName = c_uint(7) #Typ fr 31128 = 7
DeviceNumber = c_uint(1)
pFileName = c_char_p("D:\USB31128-basicCON31128\usb31128_120.cfd")
pFirmwareErrorCode = pointer(c_ubyte())

RelVal_1_32 = c_uint(0xffff) #WERTE fr Relays (bitorientiert)
RelVal_33_64 = c_uint(0x0000) #WERTE fr Relays (bitorientiert)
RelVal_65_96 = c_uint(0x0000) #WERTE fr Relays (bitorientiert)
RelVal_97_128 = c_uint(0x0000) #WERTE fr Relays (bitorientiert)




# MAIN
# get driver Info

error = DLL.GUSB_Platform_Driver_Info(pDriverInfo, LengthInByte)
if error != 0:
  print "Error in : %X" %error
  
print "USB Driver Info: DLL Version %i, DriverVersion %i, CardCount %i:" %(pDriverInfo.contents.DllVersion, pDriverInfo.contents.DriverVersion, pDriverInfo.contents.CardCount)
i = 0
while pDriverInfo.contents.CardInfo[i].PID != 0:
  print "PID %X, Typ %d, SerialNumber %d" %(pDriverInfo.contents.CardInfo[i].PID, pDriverInfo.contents.CardInfo[i].TypeIndex, pDriverInfo.contents.CardInfo[i].Serial) #PID fr 31128 = 0x4003, Typ = 7
  i += 1


# Xilinx download (muss einmalig nach power on der Hardware durchgefhrt werden)

error = DLL.GUSB_Platform_Xilinx_Download(DeviceName, DeviceNumber, pFileName, pFirmwareErrorCode)
if error != 0:
  print "Error in GUSB_Platform_Xilinx_Download: %X" %error
print "\nFirmwareErrorCode of Xilinx Download:"
print pFirmwareErrorCode.contents


# Set and Update Relays

error = DLL.GUSB_Platform_31128_SetRelay(DeviceNumber, RelVal_1_32, RelVal_33_64, RelVal_65_96, RelVal_97_128)
if error != 0:
  print "Error in GUSB_Platform_31128_SetRelay: %X" %error
error = DLL.GUSB_Platform_31128_UpdateRelay(DeviceNumber)
if error != 0:
  print "Error in GUSB_Platform_31128_UpdateRelay: %X" %error



